import sys, os

#poter prendere in input un SDF di dimensione massima = MAX_CMP( 1000 mol vanno bene)
#[python: fa il conto totale delle entries, splitta su $$$$ e prende solo le prime mille]

def calculate_sdf_size(sdf_file_name):
	tot = 0
	f = open(sdf_file_name, "r")
	for l in f:
		if "$$$$" in l: tot += 1
	return tot

def split_sdf(sdf_file_name, sdf_split_name):
	tot = 0
	mol = ""
	o = open(sdf_out_name, "w")
	f = open(sdf_file_name, "r")
	for l in f:
		mol += l
		if "$$$$" in l and tot < 1001:
			o.write(mol)
			tot += 1
			mol = ""
	o.close()
	f.close()
	return

def get_mol_fields(mol):
	fields = []
	r = mol.split("\n")
	readIt = True
	for l in r:
		if ">  <" in l:
			fields.append( l.replace(">", "").replace("<", "").strip() ) 
	return fields

def get_duplicates(lista):
	ret_list = []
	for k in lista:
		if lista.count(k) > 1 and k not in ret_list:
			ret_list.append( k )
	return ret_list
			
def get_missing(lista, sdf_size):
	expected = []
	missing = []
	i = 1
	while i <= sdf_size:
		expected.append(i)
		if i not in lista: missing.append(i)
		i += 1
	return missing

#2) fare un check chimico del file:
#		a) controllare nome e numero campi oltre quello molecolare [PYTHON]
#		B) controllare che ogni mol abbia stesso numero e tipo di campi delle altre [PYTHON]	
def check_fields(sdf_file_name, sdf_size):
	mol = ""
	tot = 1
	dict_fields = {}
	f = open(sdf_file_name, "r")
	for l in f:
		mol += l
		if "$$$$" in l and tot < 1001:
			fields = get_mol_fields(mol)
			for k in fields:
				if k not in dict_fields: dict_fields[k] = []
				dict_fields[k].append(tot)
			mol = ""
			tot += 1
	
	if len(dict_fields.keys()) == 0:
		print "No fields in the input structures"
	else:
		for k in dict_fields:
			if len( dict_fields[k] ) > sdf_size:
				duplicates = get_duplicates( dict_fields[k] )
				print "The field \"" + k + "\" is not unique in molecules number " + str(duplicates)
			if len( dict_fields[k] ) == sdf_size:
				print "Field \"" + k + "\" correctly present in " + str(len( dict_fields[k] )) + " entries"
			if len( dict_fields[k] ) < sdf_size:
				missing = get_missing( dict_fields[k], sdf_size )
				print "The field \"" + k + "\" is missing in molecules number " + str(missing)
	return
	
def inchi_run(sdf_file_name, out_file_name, log_file_name):
	cmd = "./inchi-1 inputfile outputfile logfile file_errors.sdf"
	cmd += " -Tabbed -AuxNone -WarnOnEmptyStructure -FixedH"
	os.system(cmd.replace("inputfile", sdf_file_name).replace("outputfile", out_file_name).replace("logfile", log_file_name))
	return

def clean_by_inchi(inchi_file_name, sdf_input_name, sdf_clean_name):
	f = open(inchi_file_name, "r")
	seq = []
	for l in f:
		if "Structure: " in l[:15]:
			seq.append(int(l.split("\t")[0].strip().replace("Structure: ", "").strip())-1)
	f.close()
	print len(seq)
	tot = 0
	mol = ""
	o = open(sdf_clean_name, "w")
	f = open(sdf_input_name, "r")
	for l in f:
		mol += l
		if "$$$$" in l:
			if tot in seq:	
				o.write(mol)
			tot += 1
			mol = ""
	o.close()
	f.close()
	return

def inchi_check(log_file_name):
	f = open(log_file_name, "r")
	for l in f:
		if "Finished processing" in l:
			errors = l.split("structures:")[1].split("error")[0].strip()
        if "Unknown element" in l or "Multiple bonds" in l or "has more" in l or "nonexisten" in l:
            print "INCHI ERROR: " + l.strip()
        if "Too many atoms" in l or "Empty structure" in l:
            print "INCHI ERROR: " + l.strip()
        if "Unrecognized" in l or "Program error" in l or "Unknown error" in l:
            print "INCHI ERROR: " + l.strip()
        if "Cannot read counts line" in l or "Cannot interpret counts line" in l:
            print "INCHI ERROR: " + l.strip()
        if "Cannot read atom block line" in l or "Cannot interpret atom block line" in l:
            print "INCHI ERROR: " + l.strip()
        if "Cannot read bond block line" in l or "Cannot interpret bond block line" in l:
            print "INCHI ERROR: " + l.strip()
        if "Cannot read STEXT block line" in l or "Cannot read properties block line" in l:
            print "INCHI ERROR: " + l.strip()
        if "Unexpected SData header line" in l or "Bypassing to next structure" in l:
            print "INCHI ERROR: " + l.strip()
	f.close()
	if int(errors) > 0:
		print "There are a total of " + errors + " brocken structures"
	return


#def check_duplicates(inchi_file):
	#d= {}
	#f = open(inchi_file, "r")
	#for l in f:
		#if "Structure: " in l[:15]:
			#seq = int(l.split("\t")[0].strip().replace("Structure: ", "").strip())-1
			#inchi = "InChI" + l.split("InChI")[1].strip()
			#print seq, inchi
			#if inchi not in d: d[inchi] = []
			#d[inchi].append(seq)
	#f.close()
	#to_be_removed = []
	#for k in d:
		#if len(d[k]) > 1:
			#print d[k], "are duplicates"
			#to_be_removed += d[k][1:]
	#return to_be_removed


# Funzione modificata da me perche' il file output_3D.inchi viene prodotto a righe alterne
def check_duplicates(inchi_file):
	d= {}
	f = open(inchi_file, "r")
	for l in f:
		if "Structure: " in l[:15]:
			seq = int(l.split("\t")[0].strip().replace("Structure: ", "").strip())
		if "InChI=" in l[:15]:
			inchi = "InChI" + l.split("InChI")[1].strip()
			print seq, inchi
			if inchi not in d: d[inchi] = []
			d[inchi].append(seq)
	f.close()
	to_be_removed = []
	for k in d:
		if len(d[k]) > 1:
			print d[k], "are duplicates"
			to_be_removed += d[k][1:]
	return to_be_removed

def get_unique_sdf(output_3D, to_be_removed, output_3D_uniq):
	o = open(output_3D_uniq, "w")
	f = open(output_3D, "r")
	c = 1
	mol = ""
	for l in f:
		mol += l
		if "$$$$" in l:
			if c not in to_be_removed:
				o.write(mol)
			c += 1
			mol = ""
	o.close()
	f.close()
	return

